Package org.apache.solr.client.solrj.impl

## Class LBHttp2SolrClient

- java.lang.Object
- - org.apache.solr.client.solrj.SolrClient
  - - org.apache.solr.client.solrj.impl.LBSolrClient
    - - org.apache.solr.client.solrj.impl.LBHttp2SolrClient

All Implemented Interfaces:
  `Closeable`, `Serializable`, `AutoCloseable`

    public class LBHttp2SolrClient
    extends LBSolrClient

LBHttp2SolrClient or "LoadBalanced LBHttp2SolrClient" is a load balancing wrapper around `Http2SolrClient`. This is useful when you have multiple Solr servers and the requests need to be Load Balanced among them.

Do NOT use this class for indexing in leader/follower scenarios since documents must be sent to the correct leader; no inter-node routing is done.

In SolrCloud (leader/replica) scenarios, it is usually better to use `CloudSolrClient`, but this class may be used for updates because the server will forward them to the appropriate leader.

It offers automatic failover when a server goes down, and it detects when the server comes back up.

Load balancing is done using a simple round-robin on the list of servers.

If a request to a server fails by an IOException due to a connection timeout or read timeout then the host is taken off the list of live servers and moved to a 'dead server list' and the request is resent to the next live server. This process is continued till it tries all the live servers. If at least one server is alive, the request succeeds, and if not it fails.

>      SolrClient lbHttp2SolrClient = new LBHttp2SolrClient(http2SolrClient, "http://host1:8080/solr/", "http://host2:8080/solr", "http://host2:8080/solr");

This detects if a dead server comes alive automatically. The check is done in fixed intervals in a dedicated thread. This interval can be set using `LBSolrClient.setAliveCheckInterval(int)` , the default is set to one minute.

When to use this?
This can be used as a software load balancer when you do not wish to set up an external load balancer. Alternatives to this code are to use a dedicated hardware load balancer or using Apache httpd with mod_proxy_balancer as a load balancer. See Load balancing on Wikipedia

Since:
  solr 8.0
See Also:
  Serialized Form
WARNING: This API is experimental and might change in incompatible ways in the next release.

### Nested Class Summary

Nested Classes
`static class` `LBHttp2SolrClient.Builder`

### Nested classes/interfaces inherited from class org.apache.solr.client.solrj.impl.LBSolrClient

`LBSolrClient.Req, LBSolrClient.Rsp, LBSolrClient.ServerIterator, LBSolrClient.ServerWrapper`

### Field Summary

### Fields inherited from class org.apache.solr.client.solrj.impl.LBSolrClient

`aliveCheckIntervalMillis, parser, requestWriter, RETRY_CODES, zombieServers`

### Fields inherited from class org.apache.solr.client.solrj.SolrClient

`defaultCollection`

### Constructor Summary

Constructors
`LBHttp2SolrClient​(Http2SolrClient solrClient, String... baseSolrUrls)` Deprecated. Use `LBHttp2SolrClient.Builder` instead

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`void` `addQueryParams​(String queryOnlyParam)` Deprecated. you should instead set this on the passed in Http2SolrClient used by the Builder.
`Cancellable` `asyncReq​(LBSolrClient.Req req, AsyncListener<LBSolrClient.Rsp> asyncListener)`
`protected SolrClient` `getClient​(String baseUrl)`
`ResponseParser` `getParser()`
`RequestWriter` `getRequestWriter()`
`Set<String>` `getUrlParamNames()`
`void` `setParser​(ResponseParser parser)` Deprecated. Pass in a configured `Http2SolrClient` instead
`void` `setQueryParams​(Set<String> queryParams)` Deprecated. You should instead set this on the passed in Http2SolrClient used by the Builder.
`void` `setRequestWriter​(RequestWriter writer)` Deprecated. Pass in a configured `Http2SolrClient` instead

### Methods inherited from class org.apache.solr.client.solrj.impl.LBSolrClient

`addSolrServer, addZombie, close, createServerWrapper, doRequest, normalize, pickServer, removeSolrServer, request, request, request, setAliveCheckInterval, updateAliveList`

### Methods inherited from class org.apache.solr.client.solrj.SolrClient

`add, add, add, add, add, add, add, add, add, add, addBean, addBean, addBean, addBean, addBeans, addBeans, addBeans, addBeans, addBeans, addBeans, commit, commit, commit, commit, commit, commit, deleteById, deleteById, deleteById, deleteById, deleteById, deleteById, deleteById, deleteById, deleteByQuery, deleteByQuery, deleteByQuery, deleteByQuery, getBinder, getById, getById, getById, getById, getById, getById, getById, getById, getContext, getDefaultCollection, optimize, optimize, optimize, optimize, optimize, optimize, ping, ping, query, query, query, query, queryAndStreamResponse, queryAndStreamResponse, queryAndStreamResponse, request, rollback, rollback`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### LBHttp2SolrClient

    @Deprecated
    public LBHttp2SolrClient​(Http2SolrClient solrClient,
                             String... baseSolrUrls)

Deprecated.
Use `LBHttp2SolrClient.Builder` instead

### Method Detail

#### getClient

    protected SolrClient getClient​(String baseUrl)

Specified by:
  `getClient` in class `LBSolrClient`

#### setParser

    @Deprecated
    public void setParser​(ResponseParser parser)

Deprecated.
Pass in a configured `Http2SolrClient` instead
Note: This setter method is not thread-safe.

Overrides:
  `setParser` in class `LBSolrClient`
Parameters:
  `parser` - Default Response Parser chosen to parse the response if the parser were not specified as part of the request.
See Also:
  `SolrRequest.getResponseParser()`

#### getParser

    public ResponseParser getParser()

Overrides:
  `getParser` in class `LBSolrClient`

#### setRequestWriter

    @Deprecated
    public void setRequestWriter​(RequestWriter writer)

Deprecated.
Pass in a configured `Http2SolrClient` instead
Choose the `RequestWriter` to use.

By default, `BinaryRequestWriter` is used.

Note: This setter method is not thread-safe.

Overrides:
  `setRequestWriter` in class `LBSolrClient`
Parameters:
  `writer` - Default RequestWriter, used to encode requests sent to the server.

#### getRequestWriter

    public RequestWriter getRequestWriter()

Overrides:
  `getRequestWriter` in class `LBSolrClient`

#### getUrlParamNames

    public Set<String> getUrlParamNames()

#### setQueryParams

    @Deprecated
    public void setQueryParams​(Set<String> queryParams)

Deprecated.
You should instead set this on the passed in Http2SolrClient used by the Builder.

#### addQueryParams

    @Deprecated
    public void addQueryParams​(String queryOnlyParam)

Deprecated.
you should instead set this on the passed in Http2SolrClient used by the Builder.
This method should be removed as being able to add a query parameter isn't compatible with the idea that query params are an immutable property of a solr client.

#### asyncReq

    public Cancellable asyncReq​(LBSolrClient.Req req,
                                AsyncListener<LBSolrClient.Rsp> asyncListener)